UNIT MP3Com;
(* Kommunikation mit der Displayeinheit *)
INTERFACE
PROCEDURE V24WriteString(s: STRING);
PROCEDURE V24DataCheck;
FUNCTION V24ReadString: String;

IMPLEMENTATION
USES V24;

VAR SendBuf: ARRAY[0..2047] OF CHAR;
    SendBufWP,SendBufRP: WORD;

PROCEDURE V24WriteChar(c: CHAR);

BEGIN
  IF ((SendBufWP+1) MOD 2048)=SendBufRP THEN EXIT;
  SendBuf[SendBufWp]:=c;
  INC(SendBufWp);
  IF SendBufWp>2047 THEN SendBufWp:=0;
END;

PROCEDURE V24WriteString(s: STRING);
VAR zae: BYTE;
BEGIN
  FOR zae:=1 TO LENGTH(s) DO V24WriteChar(s[zae]);
  {$IFDEF DEBUG}
  Writeln(s);
  {$ENDIF}
  WHILE SendBufWP<>SendBufRP DO V24DataCheck;

END;

PROCEDURE V24DataCheck;
(* Prfen, ob was zu senden *)
BEGIN
  IF SendBufWP=SendBufRP THEN EXIT;
  IF (PORT[ComBase+6] AND 16)=0 THEN EXIT; (* CTS!!!*)
  IF (PORT[ComBase+5] AND $20) <> 0 THEN BEGIN
    SendByte(ORD(SendBuf[SendBufRP]));
    INC(SendBufRP);
    IF SendBufRP>2047 THEN SendBufRP:=0;
  END;
END;

FUNCTION V24ReadString: String;

VAR s: STRING;

BEGIN
  s:='';
  IF V24DataAvail THEN
    s:=s+CHR(V24GetByte);
  V24ReadString:=s;
  {$IFDEF DEBUG}
  WRITELN(s);
  {$ENDIF}

END;

VAR ex: BOOLEAN;
BEGIN
  SendBufWp:=0; SendBufRP:=0;
END.

